﻿using System.Data.Entity;
using CommonData;
using DataLayer.Mappings;
using SalesDomain;
namespace DataLayer.Sales
{
  public class SalesContext:DbContext
  {

    public DbSet<Customer> Customers { get; set; }
    public DbSet<Order> Orders { get; set; }
    public DbSet<LineItem> LineItems { get; set; }
    public DbSet<Product> Products { get; set; }
    public DbSet<Payment> Payments { get; set; }
    public DbSet<Category> Categories { get; set; }
    public DbSet<Promotion> Promotions { get; set; }

    protected override void OnModelCreating(DbModelBuilder modelBuilder)
    {
      modelBuilder.Configurations.Add(new LineItemMap());
      modelBuilder.Entity<Identity>().ToTable("Identities");
      modelBuilder.Entity<Contact>().ToTable("Contacts");
      modelBuilder.Entity<Customer>().ToTable("Customers");
      modelBuilder.Entity<Order>().Ignore(o => o.LineItems);

    }
    public override int SaveChanges()
    {
   
      return base.SaveChanges();
    }
  }

 
}
