﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using DataLayer.Sales;
using SalesDomain;

namespace DataLayer.Sales
{
  public class SalesContextSeedInitilializer : DropCreateDatabaseAlways<SalesContext>
  {
    protected override void Seed(SalesContext context)
    {
      var cust = new Customer("Julie", "Lerman", "julielerman@gmail.com");
      cust.CreateBillingInformation("1 Main", null, "New Orleans", "LA", "US", "11111", "012123918", "Banco de Ricardo");
      cust.CopyBillingAddressToShippingAddress();
      context.Customers.Add(cust);
      context.SaveChanges();
      context.Orders.Add(Order.CreateOrder(new CustomerForOrderTransferDTO
                                       {
                                         CustomerId = cust.Id,
                                         ShippingAddress = cust.ShippingAddress,
                                         Status = cust.Status
                                       }));
      context.Categories.Add(new Category
      {
        Name = "Toys",
        Products = new List<Product>() { new Product("Shiny New Toy", "STN1") { ListPrice = 1 } }
      });

      //try
      //{
      //  context.SaveChanges();
      //}
      //catch (Exception ex)
      //{
        
      //  throw;
      //}

      base.Seed(context);
    }
  }
}
