using System.Collections.Generic;
using System.Data;
using SalesDomain;

namespace DataLayer.Sales
{
  public class SimpleOrderRepository
  {
    private readonly SalesContext _context;
    private readonly List<Order> _newOrders = new List<Order>();
    public SimpleOrderRepository()
    {

      _context = new SalesContext();
    }

    public void UpdateLineItemsForExistingOrder(Order order)
    {
      //until I've implemented local change tracking, assume existing
      //objects are modified. Deleted unaccounted for

     foreach (var item in order.LineItems)
      {
        if (item.LineItemId > 0)
        {
          _context.Entry(item).State = EntityState.Modified;
        }
        else
        {
          _context.Entry(item).State = EntityState.Added;
        }
      }
    }

    public void AddNewOrderGraph(Order order)
    {
      _context.Orders.Add(order);
      _newOrders.Add(order);
    }


    public void Save()
    {

      _context.SaveChanges();
      //if there's a new order with line items,
      //that order just got save,but not the line items
      //now we'll apply the order's new db assigned key value
      //to those items and then savechanges again
      //this is how to get around a dependency on db assigned PK values
      //Guids are a LOT simpler though
      foreach (var order in _newOrders)
      {
        foreach (var item in order.LineItems)
        {
          item.SetOrderIdentity(order.OrderId);
        }
      }

      _context.SaveChanges();

    }
  }
}