using System.Collections.Generic;
using CommonData;

namespace SalesDomain
{
public class Customer : Contact
{
  public Customer(string firstName, string lastName, string email)
  {
    FullName = new FullName(firstName, lastName);
    EmailAddress = email;
    Status = CustomerStatus.Silver;
  }

  internal Customer()
  {
  }

  public void ChangeCustomerStatus(CustomerStatus status)
  {
    if (status==Status)
    {
      return;
    }
    {Status=status;
    }

  }

  public void CopyBillingAddressToShippingAddress()
  {
    ShippingAddress = new Address(
      BillingAddress.Street1, BillingAddress.Street2,
      BillingAddress.City, BillingAddress.Region,
      BillingAddress.Country, BillingAddress.PostalCode);
  }

  public void CreateNewShippingAddress(string street1, string street2, string city, string region, string country, string postalCode)
  {
    BillingAddress = new Address(
      street1,street2,
      city,region,
      country,postalCode);
  }

  public void CreateBillingInformation(string street1,string street2, string city,string region,string country, string postalCode,
                                        string creditcardNumber, string bankName)
  {
    BillingAddress = new Address (street1,street2, city,region,country,postalCode );
    CreditCard = new CustomerCreditCard (bankName, creditcardNumber );
  }

  public void SetCustomerContactDetails(string email, string phone,
                                        string companyName)
  {
    EmailAddress = email;
    Phone = phone;
    CompanyName = companyName;

  }

  
  public string SalesPersonId { get; private set; }
  public CustomerStatus Status { get; private set; }
  public Address ShippingAddress { get; private set; }
  public Address BillingAddress { get; private set; }
  public CustomerCreditCard CreditCard { get; private set; }
 
}

  public enum CustomerStatus
  {
    Silver = 1,
    Gold = 2,
    Platinum = 3
  }
}





