using System;

namespace SalesDomain
{
  public class LineItem
  {
    public LineItem(int orderId, int productId, int quantity, double unitPrice, double unitPriceDiscount)
    {
      OrderQty = quantity;
      ProductId = productId;
      UnitPrice = unitPrice;
      UnitPriceDiscount = unitPriceDiscount;
    }
    public int LineItemId { get; set; }

    public int OrderFk { get; private set; }
    public int ProductId { get; private set; }

    public int OrderQty { get; private set; }
    public Nullable<double> UnitPrice { get; private set; }
    public Nullable<double> UnitPriceDiscount { get; private set; }


    public double LineTotal
    {
      get
      {
        if (UnitPrice != null)
        {
          if (UnitPriceDiscount != null)
            return OrderQty * (UnitPrice.Value * (1 - UnitPriceDiscount.Value));
        }
        return 0;
      }
    }

    public void SetOrderIdentity(int orderId)
    {
      OrderFk = orderId;
    }


    


    public Nullable<int> ShipmentId { get; set; }
  }
}